<template>
    <div class="container">
        <div class="row">
            <div class="col-4">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5 class="m-0">{{ type == 'create' ? 'Create' : 'Update' }} Author</h5>
                    </div>
                    <div class="card-body">
                        <div class="form-floating mb-3">
                            <input type="text" v-on:keyup.enter="onEnter" v-model="author.name" class="form-control" id="floatingInput" placeholder="Author Name">
                            <label for="floatingInput">Author Name</label>
                        </div>
                        <div v-if="type == 'update'">
                            <button :disabled="processing" @click="updateAuthor" class="float-end btn btn-primary btn-login text-uppercase fw-bold" type="button">
                                {{ processing ? "Please wait" : (type == 'create' ? "Create" : "Update") }}
                            </button>
                            <button :disabled="processing" @click="backToCreate" class="float-end btn btn-secondary btn-login text-uppercase fw-bold me-2" type="button">
                                Cancel
                            </button>
                        </div>
                        <div v-else>
                            <button :disabled="processing" @click="createAuthor" class="float-end btn btn-primary btn-login text-uppercase fw-bold" type="button">
                                {{ processing ? "Please wait" : (type == 'create' ? "Create" : "Update") }}
                            </button>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-8">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5 class="m-0">Author List</h5>
                    </div>
                    <div class="card-body">
                        <div v-if="validationMessage" :class="'col-12 alert '+validationMessage.alert">
                            {{ validationMessage.message }}
                        </div>
                        <table class="table table-compact table-hover">
                            <thead>
                                <tr>
                                    <th>#</th>
                                    <th>Author Name</th>
                                    <th class="text-center">Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(author, index) in getterListAuthors.data" :key="author.id">
                                    <td>{{ index + 1 }}</td>
                                    <td>{{ author.name }}</td>
                                    <td class="text-center">
                                        <a class="mx-2 btn btn-sm btn-danger" @click="deleteAuthor(author.id)" href="#">Delete</a>
                                        <a class="mx-2 btn btn-sm btn-warning" @click="editAuthor(author)" href="#">Edit</a>
                                    </td>
                                </tr>
                            </tbody>
                        </table>

                        <pagination align="center" :data="getterListAuthors" @pagination-change-page="listAuthors"></pagination>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { Bootstrap5Pagination as pagination } from 'laravel-vue-pagination';
import { mapActions } from 'vuex';

export default {
    name: "author",
    components: {
        pagination
    },
    data(){
        return {
            author: {
                id: null,
                name: null
            },
            type: 'create',
            processing: false,
            currentPage: 1
        }
    },
    mounted(){
        this.$store.dispatch('author/list', this.currentPage)
    },
    computed: {
        getterListAuthors(){
            return this.$store.getters['author/authors'];
        },
        validationMessage(){
            return this.$store.getters['author/validationMessage'];
        }
    },
    methods: {
        ...mapActions({
        }),
        backToCreate(){
            this.type = 'create'
            this.author.name = null
        },
        onEnter(){
           if(this.type == 'update'){
                this.updateAuthor()
           }else{
                this.createAuthor()
           }
        },
        async listAuthors(page = 1){
            this.$store.dispatch('author/list', page)
            this.$router.push({ query: { page: page } })
        },
        async createAuthor(){
            this.processing = true
            setTimeout(() => {
                this.$store.dispatch('author/create', this.author)
                .then((response) => {
                    this.$store.dispatch('author/list', this.currentPage)
                    this.author.name = null
                    this.processing = false
                })
                .catch((response) => {
                    this.processing = false
                })
            }, 1000)
        },
        async deleteAuthor(id){
            if(confirm('Are you sure want to delete this item?')){
                this.$store.dispatch('author/delete', id)
                .then((response) => {
                    this.$store.dispatch('author/list', this.currentPage)
                })
            }
        },
        editAuthor(author){
            this.type = 'update'
            this.author.name = author.name
            this.author.id = author.id
        },
        async updateAuthor(){
            this.processing = true
            setTimeout(() => {
                this.$store.dispatch('author/update', this.author)
                .then((response) => {
                    this.$store.dispatch('author/list', this.currentPage)
                    this.author.name = null
                    this.author.id = null
                    this.processing = false
                    this.type = 'create'
                })
                .catch((response) => {
                    this.processing = false
                })
            }, 1000)
        }
    }
}
</script>
